
# $Id: data-analysis.R,v 1.3 2005/12/08 18:30:31 jon Exp $
# $Source: /projects/starl/cvs/dp-eb/src/data-analysis.R,v $

###
### Copyright (c) 2004, 2005, David M. Blei and Jon D. McAuliffe.
### This software is distributed under the terms of the GNU
### General Public License.
###

stopifnot(Sys.getenv("DPEB_LIB")  != "");
stopifnot(Sys.getenv("DPEB_DATA") != "");

source(paste(Sys.getenv("DPEB_LIB"), "/dp-model.R", sep = ""));

data(galaxies, package = "MASS");
data(geyser,   package = "MASS");

datasets <- list(galaxies = galaxies,
                 stamp = scan(paste(Sys.getenv("DPEB_DATA"), "stamp.dat",
                                    sep = "/"), quiet = TRUE),
                 geyser = geyser$duration);


## default parameters:

## m = 10
## b = 100
## lag = 1
## burn.in = 100
## num.rounds = 200

do.gaussian.analysis <- function(dataset, output.dir, alpha.init = NULL,
                                 m = 10, b = 200,
                                 lag = 1, burn.in = 100, num.rounds = 200)
{
  ddata <- function(y, thetas)
    dnorm(y, mean = thetas, sd = data.sd.hat);

  dp.eb.fit.model(dataset, ddata, alpha.init, m, b, lag, burn.in, num.rounds,
                  should.do.data.sd.eb = TRUE,
                  seed = as.integer(Sys.time()),
                  output.dir = output.dir);
}
