
# $Id: rdp.R,v 1.4 2005/12/08 18:30:32 jon Exp $
# $Source: /projects/starl/cvs/dp-eb/src/rdp.R,v $

###
### Copyright (c) 2004, 2005, David M. Blei and Jon D. McAuliffe.
### This software is distributed under the terms of the GNU
### General Public License.
###

new.dp <- function(rg0, alpha)
{
  e <- new.env();
  evalq({

    draw <- function() {
      counts <- sapply(vals, function(v) { v$count; });

      if (length(counts)>0)
        prop <- c(counts, alpha)/(sum(counts) + alpha)
      else
        prop <- c(1);

      k <- which(rmultinom(1,1,prop)==1);
      if (k == length(counts) + 1)
        vals[[k]] <<- list(val=rg0(1), count=0);

      vals[[k]]$count <<- vals[[k]]$count + 1;
      return(vals[[k]]$val);
    }

    rg0 <- rg0
    vals <- list();
    alpha <- alpha; }, envir=e);

  return(e);
}



rdp <- function(n, dp)
{ sapply(1:n, function(i) evalq({ draw() }, envir=dp)); }



dp.values <- function(dp)
{ evalq(vals, envir=dp); }
